USE [COWS]
GO
/****** Object:  StoredProcedure [web].[GetRelatedActyForSelectedIPAddress]    Script Date: 01/08/2021 9:34:06 PM ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
-- =============================================
-- Author:		Caranay, John
-- Create date: 01/14/2021
-- Description:	Get IP Records
-- Updated:
--		
-- =============================================
ALTER PROCEDURE [dbo].[GetIPRecords]  
	-- Add the parameters for the stored procedure here
	@IP_TYPE SMALLINT -- 1 = CARRIER | 2 = SIP
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

	DECLARE @INDEX INT;
	DECLARE @TOTALCOUNT INT;


	DECLARE @IDARR table (ID INT, ARRAYINDEX int identity(1,1) )  

	SET @INDEX = 0;

	-- INSERT ID ON TEMP TABLE
	INSERT INTO @IDARR(ID)
	SELECT ID FROM LK_IP_MSTR;

	-- GET TOTAL COUNT
	SELECT @TOTALCOUNT = COUNT(*) FROM @IDARR;

	DECLARE @IPRecords AS TABLE 
	(	
		ID INT identity(1,1) PRIMARY KEY,
		PARENT_ID INT,					-- TREE VIEW determiner

		-- LAYER 1
		LK_IP_MSTR_ID INT,				--LK_IP_MSTR
		SYSTEM_CD NVARCHAR(50),			--LK_IP_MSTR
		STRT_IP_ADR NVARCHAR(50),		--LK_IP_MSTR
		END_IP_ADR NVARCHAR(50),		--LK_IP_MSTR

		-- LAYER 2
		IP_MSTR_ID INT,		--IP_MSTR
		IP_ADR VARCHAR(15) ,	--IP_MSTR

		--CARRIER ETHERNET
		NID_SERIAL_NBR NVARCHAR(50),
		NID_HOST_NME NVARCHAR(50),
		M5_ORDR_NBR NVARCHAR(50),
		DEVICE_ID NVARCHAR(50),
		EVENT_ID NVARCHAR(50),
		--SIP/NAT
		DD_APRVL_NBR NVARCHAR(50),

		--COMMON
		H6 NVARCHAR(50),				-- BOTH CARRIER ETHERNET and SIP/NAT
		REC_STUS_ID INT,				--LK_IP_MSTR, IP_MSTR, ACTY
		STUS_DES NVARCHAR(50)			--LK_IP_MSTR, IP_MSTR, ACTY
	
	)

	INSERT INTO @IPRecords(PARENT_ID, LK_IP_MSTR_ID, SYSTEM_CD, STRT_IP_ADR, END_IP_ADR, REC_STUS_ID, STUS_DES)
	SELECT 0, ID, lim.SYSTM_CD, lim.STRT_IP_ADR, lim.END_IP_ADR, lim.REC_STUS_ID, ls.STUS_DES
	FROM LK_IP_MSTR as lim		 
		LEFT JOIN LK_STUS as ls ON lim.REC_STUS_ID = ls.STUS_ID


	WHILE @INDEX < @TOTALCOUNT
	BEGIN
		-- INDEX STARTS AT 1 BECAUSE OF THE TEMP INDEX
		SELECT @INDEX = @INDEX + 1;
		-- GET ID
		DECLARE @ID INT;
		SELECT @ID = ID FROM @IDARR WHERE ARRAYINDEX = @INDEX;

		DECLARE @PARENT_ID INT;
		SELECT  @PARENT_ID = ID FROM @IPRecords WHERE LK_IP_MSTR_ID = @ID;

		DECLARE @startRange BIGINT 
		DECLARE @endRange BIGINT 

		-- Fetch Start and End Range
		SELECT  @startRange = dbo.IPAddressToInteger(STRT_IP_ADR), @endRange = dbo.IPAddressToInteger(END_IP_ADR)  FROM LK_IP_MSTR WHERE ID = @id;

		DECLARE @TempIpMstr AS TABLE 
		(	
			ID INT NOT NULL PRIMARY KEY,
			PARENT_ID INT,
			IP_ADR VARCHAR(15) NOT NULL,
			REC_STUS_ID INT,
			STUS_DES VARCHAR(20),
			IP_INT BIGINT
		)

			-- Insert into Temp table to be able to filter the IP by range
		INSERT INTO @TempIpMstr(ID, PARENT_ID, IP_ADR, REC_STUS_ID, STUS_DES, IP_INT)
		SELECT 
			im.IP_MSTR_ID, 
			@PARENT_ID,
			im.IP_ADR, 
			im.REC_STUS_ID, 
			ls.STUS_DES, 
			dbo.IPAddressToInteger(IP_ADR) as IP_INT 
		FROM IP_MSTR as im
		LEFT JOIN LK_STUS as ls ON im.REC_STUS_ID = ls.STUS_ID
		ORDER BY IP_ADR;

		INSERT INTO @IPRecords(PARENT_ID, LK_IP_MSTR_ID, IP_MSTR_ID, IP_ADR, REC_STUS_ID, STUS_DES)
		-- Select and filter record by Start and End Range of LK_IP_MSTR
		SELECT PARENT_ID, @ID, ID, IP_ADR, REC_STUS_ID, STUS_DES
		FROM @TempIpMstr 
		WHERE IP_INT >= @startRange and IP_INT <= @endRange
		ORDER BY IP_INT ASC;

		DELETE FROM @TempIpMstr;
	END


	IF @IP_TYPE = 1
		BEGIN
			INSERT INTO @IPRecords(PARENT_ID, IP_MSTR_ID, NID_SERIAL_NBR, NID_HOST_NME, H6, M5_ORDR_NBR, DEVICE_ID, EVENT_ID, REC_STUS_ID, STUS_DES)
			SELECT 
				(SELECT ID FROM @IPRecords WHERE IP_MSTR_ID = im.IP_MSTR_ID),
				im.IP_MSTR_ID,
				na.NID_SERIAL_NBR,
				na.NID_HOST_NME,
				na.H6, 
				na.M5_ORDR_NBR,
				focli.DEVICE_ID,
				na.EVENT_ID,
				ia.REC_STUS_ID,
				ls.STUS_DES
			FROM IP_MSTR as im
			JOIN IP_ACTY as ia ON im.IP_MSTR_ID = ia.IP_MSTR_ID
			JOIN LK_STUS as ls ON ia.REC_STUS_ID = ls.STUS_ID
			JOIN NID_ACTY as na ON ia.NID_ACTY_ID = na.NID_ACTY_ID
			JOIN FSA_ORDR_CPE_LINE_ITEM as focli ON na.FSA_CPE_LINE_ITEM_ID = focli.FSA_CPE_LINE_ITEM_ID;
		END
	ELSE
		BEGIN
			INSERT INTO @IPRecords(PARENT_ID, IP_MSTR_ID, DD_APRVL_NBR, H6, REC_STUS_ID, STUS_DES)
			SELECT 
				(SELECT ID FROM @IPRecords WHERE IP_MSTR_ID = im.IP_MSTR_ID),
				im.IP_MSTR_ID, 
				nsa.DD_APRVL_NBR, 
				nsa.h6, 
				ia.REC_STUS_ID,
				ls.STUS_DES as StusDes
			FROM IP_MSTR as im
			JOIN IP_ACTY as ia ON im.IP_MSTR_ID = ia.IP_MSTR_ID
			JOIN LK_STUS as ls ON ia.REC_STUS_ID = ls.STUS_ID
			JOIN NAT_SIP_ACTY as nsa ON ia.NAT_SIP_ACTY_ID = nsa.NAT_SIP_ACTY_ID
		END

	SELECT * FROM @IPRecords ORDER BY ID;
END
